<script>
	export let data
	export let heightWriter = false
	export let selectedYear

	import { getContext, tick } from "svelte"
	import { LayerCake, Svg } from "layercake"
	import { isDesktop } from "~/stores.js"
	import MapSvg from "./MapSvg.svelte"

	const { mapHeight } = getContext("ComparableMap")

	let node

	let blockResize = false

	let resizedOnMobile = false

	async function handleWindowResize() {
		// resize only once on mobile; on start
		if (!$isDesktop) {
			if (resizedOnMobile) {
				return
			}
			resizedOnMobile = true
		}
		if (!heightWriter || blockResize) {
			return
		}
		await tick()
		const documentHeight = document.documentElement.clientHeight
		const y = node.getBoundingClientRect().y
		const margin = 10
		$mapHeight = documentHeight - y - margin
	}

	handleWindowResize()
</script>

<svelte:window on:resize={handleWindowResize} />

<div bind:this={node}>
	<div style={$mapHeight && `height: ${$mapHeight}px;`}>
		<LayerCake {data} containerHeight={$mapHeight}>
			<Svg>
				<MapSvg {selectedYear} />
			</Svg>
		</LayerCake>
	</div>
</div>
